"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.envPlugin = exports.envPublicPath = void 0;
exports.envPublicPath = '/vite/env';
exports.envPlugin = ({ app, config }) => {
    const mode = config.mode || 'development';
    const env = JSON.stringify({
        ...config.env,
        BASE_URL: '/',
        MODE: mode,
        DEV: mode === 'development',
        PROD: mode === 'production'
    });
    app.use((ctx, next) => {
        if (ctx.path === exports.envPublicPath) {
            ctx.type = 'js';
            ctx.body = `export default ${env}`;
            return;
        }
        return next();
    });
};
//# sourceMappingURL=serverPluginEnv.js.map